%global year 2016
%global month 11

#
# disables the check: brp-java-repack-jars
# needed that the following error do not happen:
#  Unhandled exception: java.lang.RuntimeException: Bytecode jar contains
#  unexpected file META-INF/
#     in  (src/stage2/gen/NQP.nqp)
#
%define __jar_repack %{nil}


# disable empty nqp-debug package
%define debug_package %{nil}


Name:           rakudo-jvm
Version:        0.%{year}.%{month}
Release:        1%{?dist}
Summary:        This is Rakudo Perl, a Perl 6 compiler for the MoarVM and JVM.
License:        Artistic 2.0
URL:            http://www.rakudo.org/

Source0:        http://rakudo.org/downloads/rakudo/rakudo-%{year}.%{month}.tar.gz

BuildRequires:  perl(ExtUtils::Command)
BuildRequires:  perl(Test::Harness)


# architectures where the Perl 6 compier for the JVM could not be built are
# excluded
%define build_jvm_exec 1
%ifarch i686 aarch64 ppc64 ppc64le armv7hl
%define build_jvm_exec 0
%endif

BuildRequires:  jpackage-utils
BuildRequires:  java
BuildRequires:  java-devel

Requires:       java

BuildRequires:  nqp-jvm >= 0.0.%{year}.%{month}
Requires:       nqp-jvm >= 0.0.%{year}.%{month}


# Needed for desktop-file-install usage
BuildRequires:  desktop-file-utils



%description
Rakudo Perl 6, or just Rakudo, is a Perl 6 compiler targeting the MoarVM and
the JVM. Is is an implementation of the Perl 6 specification.
More information about Perl 6 is available from: http://perl6.org


%prep
%setup -q -n rakudo-%{year}.%{month}


%build
%{__perl} Configure.pl --backends=jvm --prefix=/usr   # --backends=moar,jvm  (default is both,if both nqps are found (nqp-m and nqp-j) otherwise the moar backend only will be used)
CFLAGS=$RPM_OPT_FLAGS make %{?_smp_mflags}


%install
%make_install

# perl6--m is the default for the perl6 executable
rm -f $RPM_BUILD_ROOT/%{_bindir}/perl6

# Generating man-pages
%{__perl} -MExtUtils::Command -e mkpath $RPM_BUILD_ROOT%{_mandir}/man1
pod2man --section=1 --name=perl6-j docs/running.pod | %{__gzip} -c > $RPM_BUILD_ROOT%{_mandir}/man1/perl6-j.1.gz



%check
%{?!_without_tests:
# At the fedora (koji) build environment some tests fails, this tests are
# removed.
%ifarch x86_64
rm -rf t/04-nativecall/*
%endif

%ifarch ppc64 ppc64le armv7hl
rm -rf t/04-nativecall/02-simple-args.t
%endif

%ifarch armv7hl
rm -f t/04-nativecall/08-callbacks.t
%endif

%{__make} test
}


%files
%doc README.md CREDITS docs/module_management.md
%license LICENSE

%{_bindir}/perl6*
%{_datadir}/*


%changelog
* Fri Dec 16 2016 Gerd Pokorra <gp@zimt.uni-siegen.de> 0.2016.07-1
- initial spec file for the new review
